#include "stdafx.hpp"

namespace
{
	class QueueCUI : public uie::container_uie_window_v3
	{
	public:
		LRESULT on_message(HWND wnd, uint32_t msg, WPARAM wp, LPARAM lp) final
		{
			switch (msg)
			{
			case WM_CREATE:
				m_list.CreateInDialog(wnd, IDC_LIST);
				m_list.set_row_style(m_config.shade_alternate_rows);
				m_list.ui_fonts_changed();
				m_list.update_item_tf(m_config.item_tf);
				return 0;
			case WM_SIZE:
				m_list.SetWindowPos(nullptr, 0, 0, LOWORD(lp), HIWORD(lp), SWP_NOZORDER);
				return 0;
			case WM_CONTEXTMENU:
				m_list.on_context_menu(CPoint(lp), m_config);
				return 0;
			default:
				return DefWindowProcW(wnd, msg, wp, lp);
			}
		}

		const GUID& get_extension_guid() const final
		{
			return guids::viewer_cui;
		}

		uie::container_window_v3_config get_window_config() final
		{
			return { L"QueueViewerWindowCUI" };
		}

		uint32_t get_type() const final
		{
			return uie::type_panel;
		}

		void get_category(pfc::string_base& out) const final
		{
			out = "Panels";
		}

		void get_config(stream_writer* writer, abort_callback& abort) const final
		{
			m_config.get(writer, abort);
		}

		void get_name(pfc::string_base& out) const final
		{
			out = Component::name;
		}

		void set_config(stream_reader* reader, size_t size, abort_callback& abort) final
		{
			m_config.set(reader, size, abort);
		}

	private:
		QueueConfig m_config;
		QueueList m_list;
	};

	static uie::window_factory<QueueCUI> g_queue_cui;
}
