#include "stdafx.hpp"
#include "QueueConfig.hpp"

QueueConfig::QueueConfig()
{
	reset();
}

void QueueConfig::get(stream_writer* writer, abort_callback& abort) const
{
	try
	{
		writer->write_object_t(config_version, abort);
		writer->write_string(item_tf, abort);
		writer->write_string(sort_by, abort);
		writer->write_object_t(shade_alternate_rows, abort);
	}
	catch (...) {}
}

void QueueConfig::reset()
{
	item_tf = item_tf_default;
	sort_by = sort_by_default;
	shade_alternate_rows = true;
}

void QueueConfig::set(stream_reader* reader, size_t size, abort_callback& abort)
{
	reset();

	if (size > sizeof(uint32_t))
	{
		try
		{
			uint32_t version{};
			reader->read_object_t(version, abort);
			reader->read_string(item_tf, abort);
			if (version >= 2U)
			{
				reader->read_string(sort_by, abort);
			}
			if (version >= 3U)
			{
				reader->read_object_t(shade_alternate_rows, abort);
			}
		}
		catch (...)
		{
			reset();
		}
	}
}
